## dtkdeclarative 5.6.0

=== CMakeLists.txt ===
cmake_minimum_required (VERSION 3.10)

project (DtkDeclarative
	VERSION "${DTK_REPO_MODULE_VERSION}"
	DESCRIPTION "DTK Declarative module"
	HOMEPAGE_URL ""
	LANGUAGES CXX C
)

find_package (Qt5 CONFIG REQUIRED COMPONENTS DBus Xml)

set (BUILD_DOCS ON CACHE BOOL "Generate doxygen-based documentation")

if (BUILD_DOCS)
	add_subdirectory(docs)
endif ()

=== docs/CMakeLists.txt ===
cmake_minimum_required (VERSION 3.10)

find_package (Doxygen REQUIRED)

set (QCH_INSTALL_DESTINATION ${CMAKE_INSTALLL_PREFIX}/share/DDE/dtk CACHE STRING "QCH install location")

set (DOXYGEN_GENERATE_HTML "NO" CACHE STRING "Doxygen HTML output")
set (DOXYGEN_GENERATE_XML "NO" CACHE STRING "Doxygen XML output")
set (DOXYGEN_GENERATE_QHP "YES" CACHE STRING "Doxygen QHP output")
set (DOXYGEN_FILE_PATTERNS *.cpp *.h *.zh_CN.md *.zh_CN.dox CACHE STRING "Doxygen File Patterns")
set (DOXYGEN_PROJECT_NUMBER ${CMAKE_PROJECT_VERSION} CACHE STRING "") # Should be the same as this project is using.
set (DOXYGEN_EXTRACT_STATIC YES)
set (DOXYGEN_OUTPUT_LANGUAGE "Chinese" CACHE STRING "Doxygen Output Language")
set (DOXYGEN_IMAGE_PATH ${CMAKE_CURRENT_LIST_DIR}/images/)
set (DOXYGEN_QHG_LOCATION "qhelpgenerator")
set (DOXYGEN_QHP_NAMESPACE "org.deepin.dtk.declarative")
set (DOXYGEN_QCH_FILE "dtkdeclarative.qch")
set (DOXYGEN_QHP_VIRTUAL_FOLDER "dtkdeclarative")
set (DOXYGEN_HTML_EXTRA_STYLESHEET "" CACHE STRING "Doxygen custom stylesheet for HTML output")
set (DOXYGEN_TAGFILES "qtcore.tags=qthelp://org.qt-project.qtcore/qtcore/" CACHE STRING "Doxygen tag files")

set (DOXYGEN_PREDEFINED
    "D_DECL_DEPRECATED_X(x)="
    "\"DCORE_BEGIN_NAMESPACE=namespace Dtk { namespace Core {\""
    "\"DCORE_END_NAMESPACE=}}\""
    "\"DCORE_USE_NAMESPACE=using namespace Dtk::Core\;\""
    "\"DQUICK_BEGIN_NAMESPACE=namespace Dtk { namespace Quick {\""
    "\"DQUICK_END_NAMESPACE=}}\""
    "\"DQUICK_USE_NAMESPACE=using namespace Dtk::Quick\;\""
)
set (DOXYGEN_MACRO_EXPANSION "YES")
set (DOXYGEN_EXPAND_ONLY_PREDEF "YES")

doxygen_add_docs (doxygen
    ${PROJECT_SOURCE_DIR}/src
    ${PROJECT_SOURCE_DIR}/docs
    ALL
    WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}
    COMMENT "Generate documentation via Doxygen"
)

install (FILES ${PROJECT_BINARY_DIR}/docs/html/dtkdeclarative.qch DESTINATION ${QCH_INSTALL_DESTINATION})

=== examples/qml-app-template/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1)

project(%{ProjectName} LANGUAGES CXX)

set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

find_package(DtkDeclarative REQUIRED)

# Application
add_subdirectory(src)

=== examples/qml-app-template/src/main/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1)

set(APP_BIN_INSTALL_DIR ${CMAKE_INSTALL_PREFIX}/bin/)
set(APP_NAME ${CMAKE_PROJECT_NAME})
add_definitions(-DAPP_NAME="${APP_NAME}")

###! main目录创建出二进制可执行文件，但启动方式由 DAppLoader
###! 中提供, 请不要在 main 中实现额外内容，请将需要实现的部分
###! 移动到 preload 插件和 maincomponent 插件中。

# Set sources
set(SRC
    main.cpp
    )

# Find the Qt5Quick library
find_package(Qt5Quick CONFIG REQUIRED)

# Add EXE
add_executable(${APP_NAME} ${SRC})

# 由于 EXE 只是作为启动程序加载 LIB 使用，一般来说，只需链接 ${LIB_NAME} 既可。
target_link_libraries(${APP_NAME}
    Qt5::Quick
    ${DtkDeclarative_LIBRARIES}
    )

set_target_properties(${APP_NAME} PROPERTIES INSTALL_RPATH ${DTK_QML_APP_PLUGIN_PATH})
install(TARGETS ${APP_NAME} DESTINATION ${APP_BIN_INSTALL_DIR})
install(FILES "${CMAKE_CURRENT_SOURCE_DIR}/../../${CMAKE_PROJECT_NAME}.desktop" DESTINATION share/applications)

=== examples/qml-app-template/src/maincomponentplugin/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1)

set(MAINCOMPONENT_LIB_NAME dtkqml-${CMAKE_PROJECT_NAME})

###! maincomponent 中可以添加应用的第三方依赖、注册
###! 应用的c++和qml类型、进行耗时计算和加载等等。
###! 但为了最大程度的启动（创建）组件，请保证在 main.qml
###! 中 AppLoader 结构的正确性，将互相独立的组件独立成
###! 不同的 Component 进行并发加载。

# Set sources
set(MAINCOMPONENNT_SRC
    maincomponentplugin.cpp
    )

# Find the Qt5Quick library
find_package(Qt5Quick CONFIG REQUIRED)
find_package(Qt5QuickCompiler REQUIRED)

qtquick_compiler_add_resources(MAINCOMPONENT_RCC_SOURCES maincomponent.qrc)

# 保证 maincomponentplugin 目录下头文件全局可见
include_directories(src/maincomponentplugin)

# Add LIB
add_library(${MAINCOMPONENT_LIB_NAME} SHARED
    ${MAINCOMPONENNT_SRC}
    ${MAINCOMPONENT_RCC_SOURCES}
    )

# 由于 LIB 程序为本项目的功能实现部分，需要用到的第三方库都需要在此处添加。
target_link_libraries(${MAINCOMPONENT_LIB_NAME}
    Qt5::Quick
    ${DtkDeclarative_LIBRARIES}
    )

# Add install rule
install(TARGETS ${MAINCOMPONENT_LIB_NAME} DESTINATION ${DTK_QML_APP_PLUGIN_PATH})

=== examples/qml-app-template/src/preloadplugin/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1)

set(PRELOAD_LIB_NAME dtkqml-${CMAKE_PROJECT_NAME}-Preload)

###! 请确保 preloadplugin 下仅依赖最少的三方内容，
###! 且不做额外的复杂操作，将第三方库和自定义类型放在
###! maincomponentplugin 中，保证程序能够快速启动。
# Set sources
set(PRELOAD_SRC
    preloadplugin.cpp
    )

# Find the Qt5Quick library
find_package(Qt5Quick CONFIG REQUIRED)
find_package(Qt5QuickCompiler REQUIRED)

qtquick_compiler_add_resources(PRELOAD_RCC_SOURCES preload.qrc)

# 保证 preloadplugin 目录下头文件全局可见
include_directories(src/preloadplugin)

# Add LIB
add_library(${PRELOAD_LIB_NAME} SHARED
    ${PRELOAD_SRC}
    ${PRELOAD_RCC_SOURCES}
    )

# 由于 LIB 程序为本项目的功能实现部分，需要用到的第三方库都需要在此处添加。
target_link_libraries(${PRELOAD_LIB_NAME}
    Qt5::Quick
    ${DtkDeclarative_LIBRARIES}
    )

# Add install rule
install(TARGETS ${PRELOAD_LIB_NAME} DESTINATION ${DTK_QML_APP_PLUGIN_PATH})

=== debian/changelog ===
dtkdeclarative (5.6.0-1) unstable; urgency=medium

  * update

 -- Deepin Packages Builder <packages@deepin.com>  Fri, 11 Nov 2022 18:11:27 +0800

dtkdeclarative (0.0.1) unstable; urgency=medium

  * Initial release.

 -- Deepin Packages Builder <packages@deepin.com>  Wed, 01 Jul 2020 14:14:35 +0800

=== debian/control ===
Source: dtkdeclarative
Section: libs
Priority: optional
Maintainer: Deepin Packages Builder <packages@deepin.com>
Build-Depends:
 debhelper (>= 9),
 qtdeclarative5-dev,
 qtbase5-dev-tools,
 qtquickcontrols2-5-dev,
 libdtkgui-dev,
 libdtkcore-dev,
 qtdeclarative5-private-dev,
 qtbase5-private-dev,
 pkg-kde-tools,
 libgtest-dev
Standards-Version: 3.9.8
Homepage: http://www.deepin.org

Package: qml-module-qtquick-controls2-styles-chameleon
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, qml-module-qtquick-shapes (>= 5.11.3),
 libdtkdeclarative5( =${binary:Version})
Description: Deepin Tool Kit Qt Quick Controls 2 QML module
 Dtkdeclarative is base library of Deepin Qt/QtQuick applications.

Package: libdtkdeclarative5
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Description: Deepin Tool Kit Gui library
 Dtkdeclarative is base library of Deepin Qt/QtQuick applications.
 .
 This package contains the shared libraries.

Package: libdtkdeclarative-dev
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libdtkdeclarative5( =${binary:Version})
Description: Deepin Tool Kit Gui Devel library
 Dtkdeclarative is base library of Deepin Qt/QtQuick applications.
 .
 This package contains the header files and shared libraries of DtkDeclarative
 
Package: dtk-exhibition
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends},
 libdtkdeclarative5( =${binary:Version}),
 qml-module-qtquick-controls2-styles-chameleon( =${binary:Version})
Description: Deepin Tool Kit QML Controls example.
 .
 This package contains a applicatioin.

=== debian/rules ===
#!/usr/bin/make -f
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk
export QT_SELECT = qt5

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

ifneq (,$(wildcard .git/config))
	CONFIG_VERSION=
else
VERSION = $(DEB_VERSION_UPSTREAM)
_PACK_VER = $(shell echo $(VERSION) | awk -F'[+_~-]' '{print $$1}')
_BUILD_VER = $(shell echo $(VERSION) | awk -F'[+_~-]' '{print $$2}' | sed 's/[^0-9]//g')
ifeq ($(_BUILD_VER),)
	CONFIG_VERSION = $(_PACK_VER)
else
	CONFIG_VERSION = $(_PACK_VER).$(_BUILD_VER)
endif
endif

%:
	dh $@ --buildsystem=qmake --parallel --with qmlcdeps

override_dh_auto_configure:
	dh_auto_configure -- LIB_INSTALL_DIR=/usr/lib/$(DEB_HOST_MULTIARCH) VERSION=$(CONFIG_VERSION) DTK_QML_APP_PLUGIN_PATH=/usr/lib/$(DEB_HOST_MULTIARCH)/dtkdeclarative/qml-app

## dtkdeclarative 5.6.32

=== chameleon/CMakeLists.txt ===
set(PLUGIN_NAME ${STYLE_PLUGIN_NAME})

find_package(Dtk${DTK_VERSION_MAJOR}Gui REQUIRED)
find_package(Qt${QT_VERSION_MAJOR} COMPONENTS
    Qml
    Quick
    QuickControls2 REQUIRED
)
if(EnableQt5)
    find_package(Qt${QT_VERSION_MAJOR}QuickCompiler)
endif()

set(QML_FILES
    ApplicationWindow.qml
    BusyIndicator.qml
    Button.qml
    CheckBox.qml
    CheckDelegate.qml
    ComboBox.qml
    Control.qml
    DelayButton.qml
    DialogButtonBox.qml
    Dial.qml
    Frame.qml
    GroupBox.qml
    ItemDelegate.qml
    MenuItem.qml
    Menu.qml
    MenuSeparator.qml
    PageIndicator.qml
    Pane.qml
    Popup.qml
    ProgressBar.qml
    RadioButton.qml
    RoundButton.qml
    ScrollBar.qml
    ScrollIndicator.qml
    Slider.qml
    SpinBox.qml
    StackView.qml
    Switch.qml
    TextArea.qml
    TextField.qml
    ToolTip.qml
)
set(SRC_FILES
    qtquickcontrols2chameleonstyleplugin.h qtquickcontrols2chameleonstyleplugin.cpp
)

if(EnableQt5)
    file(GLOB _qml_files ${QML_FILES})
    set(TARGETPATH "QtQuick/Controls.2/Chameleon")
    set(PLUGIN_INSTALL_DIR "${QML_INSTALL_DIR}/${TARGETPATH}")

    qtquick_compiler_add_resources(RESOURCES ${CMAKE_CURRENT_LIST_DIR}/qml.qrc)

    add_library(${PLUGIN_NAME} SHARED
        ${SRC_FILES}
        ${RESOURCES} #   qml.qrc
    )
    set_target_properties(${PLUGIN_NAME} PROPERTIES
        LIBRARY_OUTPUT_DIRECTORY "${PLUGIN_OUTPUT_DIR}/Chameleon"
    )

    find_program(COMPILER
        NAMES qmlcachegen
        REQUIRED
    )

    set(QMLC_FILES)
    foreach(QML_FILE ${_qml_files})
        get_filename_component(EXTENSION ${QML_FILE} EXT)
        if(EXTENSION STREQUAL ".qml" OR EXTENSION STREQUAL ".js" OR EXTENSION STREQUAL ".ui.qml")
            set(OUTPUT_FILE "${QML_FILE}c")
            execute_process(COMMAND ${COMPILER} ${QML_FILE} -o ${OUTPUT_FILE})
            list(APPEND QMLC_FILES ${OUTPUT_FILE})
        endif()
    endforeach()

    set(QML_DIR "${CMAKE_CURRENT_BINARY_DIR}/qmldir")
    configure_file("${CMAKE_CURRENT_LIST_DIR}/qmldir.in" "${QML_DIR}" @ONLY)
    # copy qmldir
    add_custom_command(TARGET ${PLUGIN_NAME}
       POST_BUILD
       COMMAND ${CMAKE_COMMAND} -E
       copy_if_different
       "${QML_DIR}"    #in-file
       "${PLUGIN_OUTPUT_DIR}/Chameleon/qmldir"                            #out-file
    )

    install(TARGETS ${PLUGIN_NAME} DESTINATION ${PLUGIN_INSTALL_DIR})
    install(FILES
        ${QML_DIR}
        ${_qml_files}
        ${QMLC_FILES}
        DESTINATION ${PLUGIN_INSTALL_DIR}
    )
endif()

if(EnableQt6)
    qt_add_qml_module(${PLUGIN_NAME}
        URI "Chameleon"
        VERSION "${PROJECT_VERSION}"
        CLASS_NAME QtQuickControls2ChameleonStylePlugin
        PLUGIN_TARGET ${PLUGIN_NAME}
        OUTPUT_DIRECTORY
            "${PLUGIN_OUTPUT_DIR}/Chameleon"
        NO_PLUGIN_OPTIONAL
        NO_GENERATE_PLUGIN_SOURCE
        SOURCES ${SRC_FILES}
        QML_FILES ${QML_FILES}
    )
    install(DIRECTORY "${PLUGIN_OUTPUT_DIR}/Chameleon/" DESTINATION "${QML_INSTALL_DIR}/Chameleon")
endif()

dtk_extend_target(${PLUGIN_NAME} EnableCov ${ENABLE_COV})

target_link_libraries(${PLUGIN_NAME} PRIVATE
    Qt${QT_VERSION_MAJOR}::Qml
    Qt${QT_VERSION_MAJOR}::Quick
    Qt${QT_VERSION_MAJOR}::QuickControls2
)

if(USE_QQuickStylePluginPrivate)
    target_compile_definitions(${PLUGIN_NAME} PRIVATE
        USE_QQuickStylePlugin)
    target_link_libraries(${PLUGIN_NAME} PRIVATE
        Qt${QT_VERSION_MAJOR}::QuickControls2Private
    )
endif()

=== src/CMakeLists.txt ===
include(${PROJECT_SOURCE_DIR}/src/targets.cmake)

find_package(Qt${QT_VERSION_MAJOR}QuickCompiler)

# Quick compiler gen qmlc
file(GLOB QML_RCS ${PROJECT_SOURCE_DIR}/src/dtkdeclarative_qml.qrc)
qtquick_compiler_add_resources(RESOURCES
    ${QML_RCS}
)
# Add translation source file
qt5_add_translation(QM_FILES ${TS_FILES})

add_library(${LIB_NAME} SHARED
    ${RESOURCES}
    ${QM_FILES}
)

dtk_extend_target(${LIB_NAME} EnableCov ${ENABLE_COV})

set_target_properties(${LIB_NAME} PROPERTIES
    VERSION ${CMAKE_PROJECT_VERSION}
    SOVERSION ${CMAKE_PROJECT_VERSION_MAJOR}
    EXPORT_NAME Declarative
)

target_link_libraries(${LIB_NAME}
PUBLIC
    ${LIB_NAME}_properties
PRIVATE
    ${LIB_NAME}_sources
)

# Install translations
install(FILES ${QM_FILES} DESTINATION "${TRANSLATIONS_INSTALL_PATH}")

# Install library
install(TARGETS ${LIB_NAME} EXPORT Dtk${DTK_VERSION_MAJOR}DeclarativeTargets DESTINATION "${LIB_INSTALL_DIR}")
# Install export targets
install(EXPORT Dtk${DTK_VERSION_MAJOR}DeclarativeTargets NAMESPACE Dtk:: FILE Dtk${DTK_VERSION_MAJOR}DeclarativeTargets.cmake DESTINATION "${CONFIG_INSTALL_DIR}")

=== qt6/src/CMakeLists.txt ===
include(${PROJECT_SOURCE_DIR}/src/targets.cmake)

find_package(Qt${QT_DEFAULT_MAJOR_VERSION}ShaderTools)

include(${PROJECT_SOURCE_DIR}/qt6/src/qml.cmake)
qt_add_qml_module(${LIB_NAME}
    PLUGIN_TARGET ${PLUGIN_NAME}
    URI ${URI}
    VERSION "1.0"
    SHARED
    NO_GENERATE_PLUGIN_SOURCE
    NO_PLUGIN_OPTIONAL
    QML_FILES
        ${QML_DTK_CONTROLS}
    SOURCES
        ${SRCS} ${HEADERS}
        dquickextendregister_p.h
    OUTPUT_DIRECTORY
        "${PLUGIN_OUTPUT_DIR}/${URI_PATH}"
)

dtk_extend_target(${LIB_NAME} EnableCov ${ENABLE_COV})
dtk_extend_target(${PLUGIN_NAME} EnableCov ${ENABLE_COV})

qt_add_translations(${LIB_NAME}
    TS_FILES ${TS_FILES}
    QM_FILES_OUTPUT_VARIABLE QM_FILES
)

set_target_properties(${LIB_NAME} PROPERTIES
    VERSION ${CMAKE_PROJECT_VERSION}
    SOVERSION ${CMAKE_PROJECT_VERSION_MAJOR}
    EXPORT_NAME Declarative
)

target_link_libraries(${LIB_NAME}
PUBLIC
    ${LIB_NAME}_properties
PRIVATE
    ${LIB_NAME}_sources
)

file(GLOB QML_RCS dtkdeclarative_qml.qrc dtkdeclarative_overridable_qml.qrc)
qt_add_resources(RESOURCES
    ${QML_RCS}
    ${ASSETS_RCS}
)
target_sources(${LIB_NAME} PRIVATE ${RESOURCES})

qt_add_shaders(${LIB_NAME} "_shaders_ng"
    BATCHABLE
    PRECOMPILE
    PREFIX
        "/dtk/declarative"
    FILES
        "shaders_ng/quickitemviewport.vert"
        "shaders_ng/quickitemviewport.frag"
        "shaders_ng/quickitemviewport-opaque.vert"
        "shaders_ng/quickitemviewport-opaque.frag"
        "shaders_ng/cornerscolorshader.vert"
        "shaders_ng/cornerscolorshader.frag"
        "shaders_ng/shadowmaterial.vert"
        "shaders_ng/shadowmaterial.frag"
)

include(${PROJECT_SOURCE_DIR}/qmlplugin/targets.cmake)
target_link_libraries(${PLUGIN_NAME} PRIVATE
    ${PLUGIN_NAME}_interface
    ${LIB_NAME}
)

# Install library
install(TARGETS ${LIB_NAME} EXPORT Dtk${DTK_VERSION_MAJOR}DeclarativeTargets DESTINATION "${LIB_INSTALL_DIR}")
# Install export targets
install(EXPORT Dtk${DTK_VERSION_MAJOR}DeclarativeTargets NAMESPACE Dtk${DTK_VERSION_MAJOR}:: FILE Dtk${DTK_VERSION_MAJOR}DeclarativeTargets.cmake DESTINATION "${CONFIG_INSTALL_DIR}")
# Install translations
install(FILES ${QM_FILES} DESTINATION "${TRANSLATIONS_INSTALL_PATH}")
# Install plugin
install(TARGETS ${PLUGIN_NAME} DESTINATION "${QML_INSTALL_DIR}/${URI_PATH}")
install(DIRECTORY "${PLUGIN_OUTPUT_DIR}/${URI_PATH}/" DESTINATION "${QML_INSTALL_DIR}/${URI_PATH}")

=== debian/changelog ===
dtkdeclarative (5.6.32) unstable; urgency=medium

  * fix: DCiicon has aliasing when using base64 data(Issue: https://github.com/linuxdeepin/developer-center/issues/8941)
  * fix: Menu is not blurry enough, and the arrow position is incorrect(Issue: https://github.com/linuxdeepin/developer-center/issues/8631)
  * fix: the ItemViewport's corners is not smooth

 -- Deepin Packages Builder <packages@deepin.org>  Mon, 08 Jul 2024 02:29:21 +0000

dtkdeclarative (5.6.31) unstable; urgency=medium

  * fix: modify the SearchEdit style(Issue: https://github.com/linuxdeepin/developer-center/issues/8697)
  * fix: width of insideboxborder(Issue: https://github.com/linuxdeepin/developer-center/issues/8530)
  * fix: added blurMultiplier adjustment(Issue: https://github.com/linuxdeepin/developer-center/issues/9374)
  * chore: invalid icon use application-x-desktop

 -- Deepin Packages Builder <packages@deepin.org>  Thu, 27 Jun 2024 09:11:34 +0000

dtkdeclarative (5.6.30) unstable; urgency=medium

  * fix: assert when radius is 0 in transparent window(Issue: https://github.com/linuxdeepin/developer-center/issues/8668)
  * fix: incomplete display for menu(Issue: https://github.com/linuxdeepin/developer-center/issues/8472)

 -- Deepin Packages Builder <packages@deepin.org>  Thu, 30 May 2024 02:46:31 +0000

dtkdeclarative (5.6.29) unstable; urgency=medium

  * fix: can't display local file for DciIcon

 -- Deepin Packages Builder <packages@deepin.org>  Mon, 13 May 2024 03:02:53 +0000

dtkdeclarative (5.6.28) unstable; urgency=medium

  * chore: incorrect font for SearchEdit's indicator text(Issue: https://github.com/linuxdeepin/developer-center/issues/8040)
  * chore: Adjusting the transparency of the scrollbar
    Thanks to zhangkun(Issue: https://github.com/linuxdeepin/developer-center/issues/8049)
  * fix: icon blurry when half aligned
  * chore: add margins for Popup with window's edges
  * fix: lost user settings when Handler is equal user settings(Issue: https://github.com/linuxdeepin/developer-center/issues/7647)
  * feat: support to disable shadow for FloatingPanel
  * fix: crash at DQuickItemViewport::updatePaintNode
  * fix: set shadowOffset when using DWindow
  * feat: add "blurEnabled" property to BehindWindowBlur
  * fix: remove debug code
  * fix: QSGRenderNode::matrix is error if the item in BackdropBlitter
  * fix: search icon not visible(Issue: https://github.com/linuxdeepin/developer-center/issues/8306)
  * fix: mask area exist two line for viewport(Issue: https://github.com/linuxdeepin/developer-center/issues/8313)
  * feat: add "compositionMode" property in ItemViewport
  * fix: inconsistent implicit size in dci icon

 -- Deepin Packages Builder <packages@deepin.org>  Mon, 29 Apr 2024 08:23:45 +0000

dtkdeclarative (5.6.27) unstable; urgency=medium

  * chore: settings dialog navigation font size tweak(Issue: https://github.com/linuxdeepin/developer-center/issues/7086)
  * fix: incorrect color type
  * fix: incorrect color type(Issue: https://github.com/linuxdeepin/developer-center/issues/6841)
  * chore: update entry_clear.dci(Influence: )
  * fix: incorrect control for ColorSelector
  * refact: export asynchronous property to user
  * chore: scrollbar hover color tweak(Issue: https://github.com/linuxdeepin/developer-center/issues/7784)
  * fix: support qt 6.7
  * fix: typo and uninitialized asynchronous property
  * fix: incorrect text color for MenuItem
  * fix: adjust style for HighlightPanel
  * fix: can't set placeholder text color for SearchEdit
  * fix: incorrect control themetype for ColorSelector(issue: 7952)
  * fix: build on Qt 6.7
  * feat: add BackdropBlitter on Qt6
  * feat: use BackdropBlitter for InWindowBlur on Qt6
  * chore: change theme type for exhibition
  * feat: export cache property to user
  * fix: not initialized for BehindWindowBlur
  * fix: duplicate updates of palette(Issue: https://github.com/linuxdeepin/developer-center/issues/7826)
  * fix: dci icon not centered(Issue: https://github.com/linuxdeepin/developer-center/issues/7941)

 -- Deepin Packages Builder <packages@deepin.org>  Fri, 19 Apr 2024 08:55:37 +0000

dtkdeclarative (5.6.26) unstable; urgency=medium

  * feat: add corners for BoxShadow
  * fix: warning for insideBorderColor is invalid
  * fix: missing initialization value for ShadowConfig
  * fix: MenuItem can't be highlight by keyboard
  * fix: incorrect palette in ColorSelector
  * chore: keep consistent highlight color in different themes
  * feat: support to specify theme type for window

 -- Deepin Packages Builder <packages@deepin.org>  Tue, 26 Mar 2024 05:47:35 +0000

dtkdeclarative (5.6.25) unstable; urgency=medium

  * fix: can't disable paste(Issue: https://github.com/linuxdeepin/developer-center/issues/7052)

 -- Deepin Packages Builder <packages@deepin.org>  Mon, 11 Mar 2024 01:16:26 +0000

dtkdeclarative (5.6.24) unstable; urgency=medium

  * fix: icon doesn't change when iconTheme changed
  * feat: support base64 format for icons
  * fix: build on qt5
  * fix: adjust style for launchpad used
  * fix: adjust style for launchpad used

 -- YeShanShan <yeshanshan@deepin.org>  Wed, 31 Jan 2024 18:54:10 +0800

dtkdeclarative (5.6.23) unstable; urgency=medium

  * feat: support to override for external caller
  * feat: close popup or menu on window deactivate
  * feat: Optimize flags of RenderNode
  * fix: failure passing implicit width
  * chore: enable blur for DialogTitleBar
  * fix: Multi options selected for Combobox(Issue: https://github.com/linuxdeepin/developer-center/issues/6187)
  * Revert "fix: failure passing implicit width"
  * chore: TypeError warning
  * chore: TypeError warning

 -- YeShanShan <yeshanshan@deepin.org>  Fri, 19 Jan 2024 14:18:56 +0800

dtkdeclarative (5.6.22) unstable; urgency=medium

  * fix: no translations for context menu(Issue: https://github.com/linuxdeepin/developer-center/issues/6712)

 -- Deepin Packages Builder <packages@deepin.org>  Wed, 10 Jan 2024 02:30:59 +0000



## dtkdeclarative 5.7.5

=== debian/changelog ===
dtkdeclarative (5.7.5) unstable; urgency=medium

  * chore: typo for QT_VERSION
  * fix: StyledBehindWindowBlur blur failure
  * fix: ItemDelegate/Checkdelegate hover background missing
  * feat: Export the alignment property of Combobox

 -- Deepin Packages Builder <packages@deepin.org>  Thu, 12 Dec 2024 03:03:54 +0000

dtkdeclarative (5.7.4) unstable; urgency=medium

  * fix: memory leak
  * fix: combobox highlight missing
  * fix: combobox does not display content
  * fix: Boxshadow displays abnormally in fractional scaling scenarios
  * fix(build): chameleon version 1.0

 -- Deepin Packages Builder <packages@deepin.org>  Tue, 03 Dec 2024 02:00:46 +0000

dtkdeclarative (5.7.3) unstable; urgency=medium

  [ root ]
  * UNRELEASED

 -- Deepin Packages Builder <packages@deepin.org>  Wed, 20 Nov 2024 02:19:06 +0000

dtkdeclarative (5.7.2) unstable; urgency=medium

  * fix: StyledBehindWindowBlur crash in render thread
  * fix: Adjust menu styles

 -- Deepin Packages Builder <packages@deepin.org>  Wed, 13 Nov 2024 01:53:26 +0000

dtkdeclarative (5.7.1) unstable; urgency=medium

  * feat: Use normal wrap mode instead of WordWrap for ToolTip.Text(Bug: 271423)
  * fix: the default icon is displayed incorrectly when zooming(Bug: 277471)
  * fix: shaders conflicting in qt6

 -- Deepin Packages Builder <packages@deepin.org>  Wed, 16 Oct 2024 03:30:45 +0000

dtkdeclarative (5.0.35) unstable; urgency=medium

  * release 5.0.35

 -- Mike Chen <chenke@deepin.org>  Mon, 23 Sep 2024 11:14:20 +0800

dtkdeclarative (5.6.34) unstable; urgency=medium

  * feat: support to change window effects(Issue: https://github.com/linuxdeepin/developer-center/issues/10322)
  * fix: can't move dialog window(Issue: #190)

 -- Deepin Packages Builder <packages@deepin.org>  Tue, 20 Aug 2024 05:03:51 +0000

## dtkdeclarative 5.7.12

=== chameleon/CMakeLists.txt ===
--- 
+++ 
@@ -24,6 +24,7 @@
     Frame.qml
     GroupBox.qml
     ItemDelegate.qml
+    ListView.qml
     MenuItem.qml
     Menu.qml
     MenuSeparator.qml
@@ -100,7 +101,7 @@
 if(EnableQt6)
     qt_add_qml_module(${PLUGIN_NAME}
         URI "Chameleon"
-        VERSION "${PROJECT_VERSION}"
+        VERSION "1.0"
         CLASS_NAME QtQuickControls2ChameleonStylePlugin
         PLUGIN_TARGET ${PLUGIN_NAME}
         OUTPUT_DIRECTORY

=== docs/CMakeLists.txt ===
cmake_minimum_required (VERSION 3.10)

find_package (Doxygen REQUIRED)

set (QCH_INSTALL_DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/qt${QT_VERSION_MAJOR}/doc CACHE STRING "QCH install location")

set (DOXYGEN_GENERATE_HTML "YES" CACHE STRING "Doxygen HTML output")
set (DOXYGEN_GENERATE_XML "YES" CACHE STRING "Doxygen XML output")
set (DOXYGEN_GENERATE_QHP "YES" CACHE STRING "Doxygen QHP output")
set (DOXYGEN_FILTER_PATTERNS *.qml=doxyqml CACHE STRING "Extra filter patterns")
set (DOXYGEN_FILE_PATTERNS *.cpp *.h *.zh_CN.md *.zh_CN.dox *.qml CACHE STRING "Doxygen File Patterns")
set (DOXYGEN_EXTENSION_MAPPING qml=C++ CACHE STRING "Extra extension mapping")
set (DOXYGEN_PROJECT_NUMBER ${CMAKE_PROJECT_VERSION} CACHE STRING "") # Should be the same as this project is using.
set (DOXYGEN_EXTRACT_STATIC YES)
set (DOXYGEN_OUTPUT_LANGUAGE "Chinese" CACHE STRING "Doxygen Output Language")
set (DOXYGEN_IMAGE_PATH ${CMAKE_CURRENT_LIST_DIR}/images/)
if (EnableQt5)
    find_package(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS Help)
else()
    find_package(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS ToolsTools)
endif()
get_target_property(_qhelpgenerator_location Qt${QT_VERSION_MAJOR}::qhelpgenerator IMPORTED_LOCATION)
if("${_qhelpgenerator_location}" STREQUAL "")
    set(_qhelpgenerator_location "qhelpgenerator")
endif()
set (DOXYGEN_QHG_LOCATION ${_qhelpgenerator_location} CACHE STRING "Doxygen QHG path")
set (DOXYGEN_QHP_NAMESPACE "org.deepin.dtk.declarative")
set (DOXYGEN_QCH_FILE "dtkdeclarative.qch")
set (DOXYGEN_QHP_VIRTUAL_FOLDER "dtkdeclarative")
set (DOXYGEN_HTML_EXTRA_STYLESHEET "" CACHE STRING "Doxygen custom stylesheet for HTML output")
set (DOXYGEN_TAGFILES "qtcore.tags=qthelp://org.qt-project.qtcore/qtcore/" CACHE STRING "Doxygen tag files")
set (DOXYGEM_ALIASES "signal=@typedef")
set (DOXYGEN_EXAMPLE_PATH ${CMAKE_CURRENT_LIST_DIR}/snippets/)

set (DOXYGEN_PREDEFINED
    "D_DECL_DEPRECATED_X(x)="
    "DCORE_BEGIN_NAMESPACE=namespace Dtk { namespace Core {"
    "DCORE_END_NAMESPACE=}}"
    "DCORE_USE_NAMESPACE=using namespace Dtk::Core;"
    "DQUICK_BEGIN_NAMESPACE=namespace Dtk { namespace Quick {"
    "DQUICK_END_NAMESPACE=}}"
    "DQUICK_USE_NAMESPACE=using namespace Dtk::Quick\;"
)
set (DOXYGEN_MACRO_EXPANSION "YES")
set (DOXYGEN_EXPAND_ONLY_PREDEF "YES")

doxygen_add_docs(doxygen
    ${PROJECT_SOURCE_DIR}/src
    ${PROJECT_SOURCE_DIR}/docs
    ALL
    WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}
    COMMENT "Generate documentation via Doxygen"
)

install(FILES ${PROJECT_BINARY_DIR}/docs/html/dtkdeclarative.qch DESTINATION ${QCH_INSTALL_DESTINATION})

=== examples/CMakeLists.txt ===
set(CHAMELEON_PATH "${PROJECT_BINARY_DIR}/plugins")
add_definitions(
    -DCHAMELEON_PATH="${CHAMELEON_PATH}"
    -DQT_DEPRECATED_WARNINGS
)
add_subdirectory(exhibition)
add_subdirectory(qml-inspect)

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -13,6 +13,7 @@
 add_library(${LIB_NAME} SHARED
     ${RESOURCES}
     ${QM_FILES}
+    ${PROJECT_SOURCE_DIR}/src/dtkdeclarative_shaders.qrc
 )
 
 dtk_extend_target(${LIB_NAME} EnableCov ${ENABLE_COV})

=== tests/CMakeLists.txt ===
set(BIN_NAME unit-test)

find_package(Dtk${DTK_VERSION_MAJOR}Core REQUIRED)
find_package(Dtk${DTK_VERSION_MAJOR}Gui REQUIRED)
find_package(GTest REQUIRED)
find_package(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS Core Gui Quick QuickControls2 Qml Test)

file(GLOB TEST_SOURCES
    ut_colorselector.cpp
    ut_dconfigwrapper.cpp
    ut_dqmlglobalobject.cpp
    ut_dapploader.cpp
    ut_thememenu.cpp
    ut_windowbuttongroup.cpp
    ut_dquickrectangle.cpp
    ut_dquickwindow.cpp
    ut_waterprogressbar.cpp
    ut_keysequencelistener.cpp
    ut_dsettingscontainer.cpp
    ut_buttonbox.cpp
    ut_dobjectmodelproxy.cpp
    ut_dmessagemanager.cpp
    ut_dquickarrowboxpath.cpp
    ut_dquickglow.cpp
    ut_dsoftwareroundedimagenode.cpp
    ut_dblitframebuffernode.cpp
    ut_dquickiconlabel.cpp
    ut_dquickiconimage.cpp
    ut_dquickdciiconimage.cpp
    ut_dmaskeffectnode.cpp
    ut_dquickdciicon.cpp
    ut_dblurimagenode.cpp
    ut_dhandlecontextmenuwindow.cpp
    ut_dquickbehindwindowblur.cpp
    ut_dquickinwindowblur.cpp
    ut_dquickcoloroverlay.cpp
    ut_dquickitemviewport.cpp
    ut_dquickopacitymask.cpp
    ut_dquickblitframebuffer.cpp
    ut_dtkdeclatative_qmls.cpp
)
if (EnableDtk5)
    list(APPEND TEST_SOURCES
        ut_dplatformthemeproxy.cpp
    )
endif()

add_executable(${BIN_NAME}
    main.cpp ${TEST_SOURCES}
    ${CMAKE_CURRENT_LIST_DIR}/data.qrc
)

target_compile_options(${BIN_NAME} PRIVATE
    "-fno-access-control"
)

target_compile_definitions(${BIN_NAME} PRIVATE
    QML_PLUGIN_PATH="${PLUGIN_OUTPUT_DIR}"
    CHAMELEON_PATH="${PLUGIN_OUTPUT_DIR}"
    BIN_NAME="${BIN_NAME}"
)

target_link_libraries(${BIN_NAME} PRIVATE
    Qt${QT_VERSION_MAJOR}::Test
    Qt${QT_VERSION_MAJOR}::QuickControls2
    ${LIB_NAME}
    GTest::GTest
    pthread
    dl
    m
)

set(APPLOADER_PLUGINDUMP_OUTPUT_DIR ${PROJECT_BINARY_DIR}/plugins)
target_compile_definitions(${BIN_NAME} PRIVATE
    APPLOADER_PLUGINDUMP_OUTPUT_DIR="${APPLOADER_PLUGINDUMP_OUTPUT_DIR}"
)
set(PRELOAD_LIB_NAME apploader-plugindump-preload)
set(MAINCOMPONENT_LIB_NAME apploader-plugindump-main)
add_subdirectory(apploaderplugindump)
add_dependencies(${BIN_NAME} ${PRELOAD_LIB_NAME} ${MAINCOMPONENT_LIB_NAME})

=== examples/qml-inspect/CMakeLists.txt ===
set(BIN_NAME qml-inspect)

find_package(Qt${QT_VERSION_MAJOR} COMPONENTS Quick QuickControls2)
find_package(Dtk${DTK_VERSION_MAJOR}Core REQUIRED)
find_package(Dtk${DTK_VERSION_MAJOR}Gui REQUIRED)

add_executable(${BIN_NAME}
    ${CMAKE_CURRENT_LIST_DIR}/main.cpp 
    ${CMAKE_CURRENT_LIST_DIR}/qml.qrc
    ${CMAKE_CURRENT_LIST_DIR}/dciicons.qrc
)

target_link_libraries(${BIN_NAME} PUBLIC
    Qt${QT_VERSION_MAJOR}::Quick 
    Qt${QT_VERSION_MAJOR}::QuickControls2
    Dtk${DTK_VERSION_MAJOR}::Gui
)

=== qt6/src/CMakeLists.txt ===
--- 
+++ 
@@ -25,6 +25,7 @@
 qt_add_translations(${LIB_NAME}
     TS_FILES ${TS_FILES}
     QM_FILES_OUTPUT_VARIABLE QM_FILES
+    IMMEDIATE_CALL
 )
 
 set_target_properties(${LIB_NAME} PROPERTIES
@@ -47,7 +48,7 @@
 )
 target_sources(${LIB_NAME} PRIVATE ${RESOURCES})
 
-qt_add_shaders(${LIB_NAME} "_shaders_ng"
+qt_add_shaders(${LIB_NAME} "_dtkdeclarative_shaders_ng"
     BATCHABLE
     PRECOMPILE
     PREFIX

=== tests/apploaderplugindump/maincomponentplugin/CMakeLists.txt ===
if(EnableQt5)
    qtquick_compiler_add_resources(MAINCOMPONENT_RCC_SOURCES maincomponent.qrc)
endif()
if(EnableQt6)
    qt_add_resources(MAINCOMPONENT_RCC_SOURCES maincomponent.qrc)
endif()

# Add LIB
add_library(${MAINCOMPONENT_LIB_NAME} SHARED
    maincomponentplugin.cpp
    ${MAINCOMPONENT_RCC_SOURCES}
)

target_link_libraries(${MAINCOMPONENT_LIB_NAME} PRIVATE
    ${LIB_NAME}
)

set_target_properties(${MAINCOMPONENT_LIB_NAME} PROPERTIES
    LIBRARY_OUTPUT_DIRECTORY "${APPLOADER_PLUGINDUMP_OUTPUT_DIR}"
)

=== qt6/src/qml/settings/CMakeLists.txt ===
#####################################################################
## dtkdeclarativesettingsplugin Plugin:
#####################################################################

qt_add_qml_module(dtkdeclarativesettingsplugin
    PLUGIN_TARGET dtkdeclarativesettingsplugin
    URI "${URI}.settings"
    VERSION "1.0"
    SOURCES
        ${PROJECT_SOURCE_DIR}/src/private/dsettingscontainer_p.h
        ${PROJECT_SOURCE_DIR}/src/private/dsettingscontainer.cpp
    QML_FILES
        "SettingsDialog.qml"
        "OptionDelegate.qml"
        "CheckBox.qml"
        "LineEdit.qml"
        "ComboBox.qml"
        "NavigationTitle.qml"
        "ContentTitle.qml"
        "ContentBackground.qml"
    OUTPUT_DIRECTORY
        "${PLUGIN_OUTPUT_DIR}/${URI_PATH}/settings"
)

dtk_extend_target(dtkdeclarativesettingsplugin EnableCov ${ENABLE_COV})

target_link_libraries(dtkdeclarativesettingsplugin
PRIVATE
    Qt${QT_VERSION_MAJOR}::Core
    Qt${QT_VERSION_MAJOR}::Quick
    Qt${QT_VERSION_MAJOR}::CorePrivate
    Qt${QT_VERSION_MAJOR}::QuickPrivate
    Qt${QT_VERSION_MAJOR}::Qml
    Qt${QT_VERSION_MAJOR}::QmlPrivate
    ${LIB_NAME}
)

install(TARGETS dtkdeclarativesettingsplugin DESTINATION "${QML_INSTALL_DIR}/${URI_PATH}/settings")
install(DIRECTORY "${PLUGIN_OUTPUT_DIR}/${URI_PATH}/settings/" DESTINATION "${QML_INSTALL_DIR}/${URI_PATH}/settings")

=== debian/changelog ===
dtkdeclarative (5.7.12-1build1) questing; urgency=medium

  * No-change rebuild against Qt 5.15.17.

 -- Dmitry Shachnev <mitya57@ubuntu.com>  Tue, 15 Jul 2025 13:03:48 +0300

dtkdeclarative (5.7.12-1) unstable; urgency=medium

  * New upstream release.

 -- Boyuan Yang <byang@debian.org>  Sun, 16 Mar 2025 15:30:32 -0400

dtkdeclarative (5.7.9-1) unstable; urgency=medium

  * Initial release. (Closes: #1095901)

 -- Boyuan Yang <byang@debian.org>  Thu, 13 Feb 2025 09:06:22 -0500

=== debian/rules ===
#!/usr/bin/make -f

# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all optimize=+lto

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk

VERSION = $(DEB_VERSION_UPSTREAM)
PACK_VER = $(shell echo $(VERSION) | awk -F'[+_~-]' '{print $$1}')
# Fix: invalid digit "8" in octal constant. e.g.  u008 ==> 008 ==> 8
BUILD_VER = $(shell echo $(VERSION) | awk -F'[+_~-]' '{print $$2}' | sed 's/[^0-9]//g' | awk '{print int($$1)}')

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DBUILD_EXAMPLES=OFF -DBUILD_DOCS=ON -DBUILD_VERSION=$(BUILD_VER) -DDTK_VERSION=$(PACK_VER)

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%dtkdeclarative-$1.tar.gz%" \
 https://github.com/linuxdeepin/dtkdeclarative/tags \
 (?:.*?/)?(\d[\d.]*)\.tar\.gz debian uupdate

## dtkdeclarative 5.7.14

=== misc/qml-app-template/src/preloadplugin/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1)

set(PRELOAD_LIB_NAME ${CMAKE_PROJECT_NAME}-preload)

###! 请确保 preloadplugin 下仅依赖最少的三方内容，
###! 且不做额外的复杂操作，将第三方库和自定义类型放在
###! maincomponentplugin 中，保证程序能够快速启动。
# Set sources
set(PRELOAD_SRC
    preloadplugin.cpp
)

# Find the QtQuick library
find_package(Qt${QT_VERSION_MAJOR}Quick CONFIG REQUIRED)
if(${QT_VERSION_MAJOR} EQUAL 5)
    find_package(Qt5QuickCompiler REQUIRED)
    qtquick_compiler_add_resources(PRELOAD_RCC_SOURCES preload.qrc)
else()
    qt_add_resources(PRELOAD_RCC_SOURCES preload.qrc)
    set(DTK_VERSION_MAJOR ${QT_VERSION_MAJOR})
endif()

# 保证 preloadplugin 目录下头文件全局可见
include_directories(src/preloadplugin)

# Add LIB
add_library(${PRELOAD_LIB_NAME} SHARED
    ${PRELOAD_SRC}
    ${PRELOAD_RCC_SOURCES}
)

# 由于 LIB 程序为本项目的功能实现部分，需要用到的第三方库都需要在此处添加。
target_link_libraries(${PRELOAD_LIB_NAME}
    Qt${QT_VERSION_MAJOR}::Quick
    Dtk${DTK_VERSION_MAJOR}::Declarative
)

# Add install rule
install(TARGETS ${PRELOAD_LIB_NAME} DESTINATION ${DTK_QML_APP_PLUGIN_PATH})

=== debian/changelog ===
dtkdeclarative (5.7.14) unstable; urgency=medium

  * fix: incorrect padding for MenuItem
  * fix: ScrollBar don't display when size is less
  * fix: refresh Delegate Model Slowly

 -- YeShanShan <yeshanshan@uniontech.com>  Thu, 17 Apr 2025 21:52:19 +0800

dtkdeclarative (5.7.13) unstable; urgency=medium

  * fix: wrong z order of render buffer blitter

 -- YeShanShan <yeshanshan@uniontech.com>  Thu, 20 Mar 2025 17:06:59 +0800

dtkdeclarative (5.7.12) unstable; urgency=medium

  * feat: using DConfig in the non-GUI thread
  * fix: missing FocusBorder for WindowButton in TitleBar
  * feat: Add files generated by qdbusXML2cpp and DCONG2cpp
  * fix: Popup background does not follow the theme changes
  * fix: StyledBehindWindowBlur crash in render thread

 -- YeShanShan <yeshanshan@uniontech.com>  Thu, 06 Mar 2025 17:30:28 +0800

dtkdeclarative (5.7.11) unstable; urgency=medium

  * fix: double click doesn't work for TitleBar
  * chore: replacing a way to get listview's item
  * fix: delayed color updates for MenuItem
  * fix: incorrect width for Menu
  * feat: export DSysInfo for QML
  * fit: Add focus style
  * fix: MinimizeButton behavior mismatch with qwidget

 -- YeShanShan <yeshanshan@uniontech.com>  Thu, 27 Feb 2025 20:48:40 +0800

dtkdeclarative (5.7.10) unstable; urgency=medium

  * fix: incorrect height for Menu when height is large

 -- YeShanShan <yeshanshan@uniontech.com>  Thu, 13 Feb 2025 17:19:23 +0800

dtkdeclarative (5.7.9) unstable; urgency=medium

  [ root ]
  * UNRELEASED

 -- Deepin Packages Builder <packages@deepin.org>  Thu, 23 Jan 2025 09:07:08 +0000

dtkdeclarative (5.7.8) unstable; urgency=medium

  * fix: Menu's focus not be clean
  * chore: drop shadow for BoxPanel temporarily

 -- Deepin Packages Builder <packages@deepin.org>  Tue, 14 Jan 2025 11:17:32 +0000

dtkdeclarative (5.7.7) unstable; urgency=medium

  * fix: incorrect registering way for qt6
  * fix: incorrect Highlight for Menu
  * fix: item_checked icon was clipped

 -- Deepin Packages Builder <packages@deepin.org>  Thu, 09 Jan 2025 09:28:39 +0000

dtkdeclarative (5.7.6) unstable; urgency=medium

  * fix: arrowlistview not clip
  * fix: lineedit rightpadding to small
  * fix: image cache cleared
    Thanks to Yixue Wang
  * chore: remove version of imported uri for qt6
  * fix: access nullptr when app exited
  * fix: itemdelegate icon flashed
  * fix: incorrect scaling of icons under Treeland
  * fix: adjust UI for MenuItem
  * fix: adjust UI for Menu and ComboBox
  * feat: support to flow system settings for scrollBarPolicy

 -- Deepin Packages Builder <packages@deepin.org>  Thu, 02 Jan 2025 06:46:45 +0000

## dtkdeclarative 5.7.16

=== tests/apploaderplugindump/preloadplugin/CMakeLists.txt ===
if(EnableQt5)
    qtquick_compiler_add_resources(PRELOAD_RCC_SOURCES preload.qrc)
endif()
if(EnableQt6)
    qt_add_resources(PRELOAD_RCC_SOURCES preload.qrc)
endif()

add_library(${PRELOAD_LIB_NAME} SHARED
    preloadplugin.cpp
    ${PRELOAD_RCC_SOURCES}
)

target_link_libraries(${PRELOAD_LIB_NAME} PRIVATE
    ${LIB_NAME}
)

set_target_properties(${PRELOAD_LIB_NAME} PROPERTIES
    LIBRARY_OUTPUT_DIRECTORY "${APPLOADER_PLUGINDUMP_OUTPUT_DIR}"
)

=== debian/changelog ===
dtkdeclarative (5.7.16) unstable; urgency=medium

  * fix: use applicationDisplayName instead of qAppName in
    DQMLGlobalObject
  * fix: remove redundant devicePixelRatio division in icon scaling
  * fix: correct icon image update logic
  * fix: update image source URL when source size changes

 -- YeShanShan <yeshanshan@uniontech.com>  Mon, 19 May 2025 17:22:37 +0800

dtkdeclarative (5.7.15) unstable; urgency=medium

  * feat: Improve the design of SettingsDialog to support code generated
    by dconfig2cpp

 -- YeShanShan <yeshanshan@uniontech.com>  Thu, 08 May 2025 17:53:35 +0800

## dtkdeclarative 5.7.18

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)

file(READ "${CMAKE_CURRENT_SOURCE_DIR}/VERSION" DTK_FILE_VERSION)
string(STRIP "${DTK_FILE_VERSION}" DTK_FILE_VERSION)
set(DTK_VERSION "${DTK_FILE_VERSION}" CACHE STRING "Define project version")
project(DtkDeclarative
    VERSION "${DTK_VERSION}"
    DESCRIPTION "DTK Declarative module"
    HOMEPAGE_URL "https://github.com/linuxdeepin/dtkdeclarative"
    LANGUAGES CXX
)

if (${PROJECT_VERSION_MAJOR} STREQUAL "5")
    set(QT_DEFAULT_MAJOR_VERSION "5")
    set(QT_VERSION_MAJOR "5")
    set(EnableQt5 on)
    set(EnableDtk5 on)
    set(EnableQt6 off)
    set(EnableDtk6 off)
elseif(${PROJECT_VERSION_MAJOR} STREQUAL "6")
    set(QT_DEFAULT_MAJOR_VERSION "6")
    set(QT_VERSION_MAJOR "6")
    set(DTK_VERSION_MAJOR "6")
    set(EnableQt5 off)
    set(EnableDtk5 off)
    set(EnableQt6 on)
    set(EnableDtk6 on)
else()
    message(FATAL_ERROR "Only support DTK_VERSION is 5 or 6")
endif()

set(ENABLE_COV OFF CACHE BOOL "Generate coverage info")
set(LIB_NAME dtk${DTK_VERSION_MAJOR}declarative)

set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_EXPORT_COMPILE_COMMANDS ON)
list(APPEND CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/cmake")

if(CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
    set(CMAKE_INSTALL_PREFIX /usr)
endif()
include(GNUInstallDirs)
include(CMakePackageConfigHelpers)

include(DtkBuildConfig)
set(BUILD_DOCS ON CACHE BOOL "Generate doxygen-based documentation")

set(LIB_INSTALL_DIR "${CMAKE_INSTALL_LIBDIR}" CACHE STRING "Library install path")
set(INCLUDE_INSTALL_DIR "${CMAKE_INSTALL_INCLUDEDIR}/dtk${PROJECT_VERSION_MAJOR}/DDeclarative" CACHE STRING "Headers install path")
set(TEMPLATE_INSTALL_DIR "${CMAKE_INSTALL_PREFIX}/share/qtcreator/templates/wizards/projects/qml${DTK_VERSION_MAJOR}-app-template" CACHE STRING "Directory to install QtCreator template")
set(CONFIG_INSTALL_DIR "${CMAKE_INSTALL_LIBDIR}/cmake/Dtk${DTK_VERSION_MAJOR}Declarative" CACHE STRING "CMake config file install directory")
set(PKGCONFIG_INSTALL_DIR "${CMAKE_INSTALL_LIBDIR}/pkgconfig" CACHE STRING "Directory to install pkg-config file")
set(MKSPECS_INSTALL_DIR "${CMAKE_INSTALL_LIBDIR}/qt${QT_VERSION_MAJOR}/mkspecs/modules" CACHE STRING "Qt pri module install directory")
set(QML_INSTALL_DIR "${CMAKE_INSTALL_LIBDIR}/qt${QT_VERSION_MAJOR}/qml" CACHE STRING "Qml plugin install directory")

set(USE_QQuickStylePluginPrivate OFF)
find_package(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS Core)
find_package(Qt${QT_VERSION_MAJOR}QuickControls2)
if(EnableQt5)
if(TARGET Qt::QuickControls2 AND TARGET Qt::QuickControls2Private)
    set(USE_QQuickStylePluginPrivate ON)
endif()
endif()
if(EnableQt6)
if(TARGET Qt6::QuickControls2 AND TARGET Qt6::QuickControls2Private)
    set(USE_QQuickStylePluginPrivate ON)
endif()
endif()

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fPIC -Wall -Wextra")
set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,--as-needed")
if (CMAKE_BUILD_TYPE STREQUAL "Debug")
    # 加上 ASAN 检查后可能会导致 DEBUG 应用启动后退出。可以加上 ASAN_OPTIONS 环境变量来防止应用退出
    # ASAN_OPTIONS="halt_on_error=0" ASAN_OPTIONS="new_delete_type_mismatch=0"
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -O0 -g -fno-omit-frame-pointer")
    set(BUILD_TESTING ON)
else ()
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Ofast")
endif ()

set(DDECLARATIVE_TRANSLATIONS_DIR "dtk${PROJECT_VERSION_MAJOR}/DDeclarative/translations" CACHE STRING "DDeclarative translations directory")
set(DDECLARATIVE_TRANSLATIONS_PATH "share/${DDECLARATIVE_TRANSLATIONS_DIR}")
set(TRANSLATIONS_INSTALL_PATH "${DDECLARATIVE_TRANSLATIONS_PATH}")

set(URI "org.deepin.dtk")
string(REPLACE "." "/" URI_PATH ${URI})
set(PLUGIN_NAME dtkdeclarativeplugin)
set(STYLE_PLUGIN_NAME qtquickcontrolschameleonstyleplugin)
set(PLUGIN_OUTPUT_DIR ${PROJECT_BINARY_DIR}/plugins)

if(EnableQt5)
    add_subdirectory(src)
    add_subdirectory(qmlplugin)
endif()
if(EnableQt6)
    add_subdirectory(qt6)
endif()
add_subdirectory(chameleon)
add_subdirectory(examples)

if(BUILD_DOCS)
    add_subdirectory(docs)
endif()

if(BUILD_TESTING)
    add_subdirectory(tests)
    add_dependencies(unit-test ${PLUGIN_NAME} ${STYLE_PLUGIN_NAME})
    if(EnableQt6)
        add_dependencies(unit-test dtkdeclarativeprivatesplugin dtkdeclarativesettingsplugin)
    endif()
endif()

# Install wizards template
set(QML_TEMPLATE_QTVERSION_INDEX 0)
if(EnableQt5)
    set(QML_TEMPLATE_QTVERSION_INDEX 3)
endif()
configure_package_config_file(
    "${CMAKE_CURRENT_LIST_DIR}/misc/qml-app-template/wizard.json.in"
    "${CMAKE_CURRENT_BINARY_DIR}/wizard.json"
    INSTALL_DESTINATION "${TEMPLATE_INSTALL_DIR}"
)
install(FILES "${CMAKE_CURRENT_BINARY_DIR}/wizard.json" DESTINATION "${TEMPLATE_INSTALL_DIR}")
install(DIRECTORY "${CMAKE_CURRENT_LIST_DIR}/misc/qml-app-template/" DESTINATION "${TEMPLATE_INSTALL_DIR}" FILES_MATCHING PATTERN "*" PATTERN "*.in" EXCLUDE)

configure_package_config_file(
    "${CMAKE_CURRENT_LIST_DIR}/misc/DtkDeclarativeConfig.cmake.in"
    "${CMAKE_CURRENT_BINARY_DIR}/Dtk${DTK_VERSION_MAJOR}DeclarativeConfig.cmake"
    INSTALL_DESTINATION "${CONFIG_INSTALL_DIR}"
)
write_basic_package_version_file(
    "${CMAKE_CURRENT_BINARY_DIR}/Dtk${DTK_VERSION_MAJOR}DeclarativeConfigVersion.cmake"
    VERSION ${VERSION}
    COMPATIBILITY SameMajorVersion
)
# Install cmake config file
install(FILES "${CMAKE_CURRENT_BINARY_DIR}/Dtk${DTK_VERSION_MAJOR}DeclarativeConfig.cmake" DESTINATION "${CONFIG_INSTALL_DIR}")
install(FILES "${CMAKE_CURRENT_BINARY_DIR}/Dtk${DTK_VERSION_MAJOR}DeclarativeConfigVersion.cmake" DESTINATION "${CONFIG_INSTALL_DIR}")
# Install pkg-config file
configure_file("${PROJECT_SOURCE_DIR}/misc/dtkdeclarative.pc.in" "${CMAKE_CURRENT_BINARY_DIR}/dtk${DTK_VERSION_MAJOR}declarative.pc" @ONLY)
install(FILES "${CMAKE_CURRENT_BINARY_DIR}/dtk${DTK_VERSION_MAJOR}declarative.pc" DESTINATION "${PKGCONFIG_INSTALL_DIR}")
# Install qmake module config file
configure_file("${CMAKE_CURRENT_LIST_DIR}/misc/qt_lib_dtkdeclarative.pri.in" "${CMAKE_CURRENT_BINARY_DIR}/qt_lib_dtkdeclarative.pri" @ONLY)
install(FILES "${CMAKE_CURRENT_BINARY_DIR}/qt_lib_dtkdeclarative.pri" DESTINATION "${MKSPECS_INSTALL_DIR}")

=== debian/changelog ===
dtkdeclarative (5.7.18) unstable; urgency=medium

  * Release 5.7.18

 --  yeshanshan <yeshanshan@uniontech.com>  Fri, 27 Jun 2025 17:08:30 +0800

dtkdeclarative (5.7.17) unstable; urgency=medium

  * Release 5.7.17

 -- yeshanshan <yeshanshan@uniontech.com>  Thu, 19 Jun 2025 10:06:58 +0800

## dtkdeclarative 5.7.19

=== chameleon/CMakeLists.txt ===
--- 
+++ 
@@ -35,6 +35,7 @@
     RadioButton.qml
     RoundButton.qml
     ScrollBar.qml
+    ScrollView.qml
     ScrollIndicator.qml
     Slider.qml
     SpinBox.qml

=== qt6/src/CMakeLists.txt ===
--- 
+++ 
@@ -70,6 +70,12 @@
     ${LIB_NAME}
 )
 
+# 禁用此插件的 RPATH/RUNPATH，因为依赖库在标准系统路径中
+set_target_properties(${PLUGIN_NAME} PROPERTIES
+    INSTALL_RPATH ""
+    BUILD_WITH_INSTALL_RPATH TRUE
+)
+
 # Install library
 install(TARGETS ${LIB_NAME} EXPORT Dtk${DTK_VERSION_MAJOR}DeclarativeTargets DESTINATION "${LIB_INSTALL_DIR}")
 # Install export targets

=== debian/changelog ===
dtkdeclarative (5.7.19) unstable; urgency=medium

  * Release 5.7.19

 --  yeshanshan <yeshanshan@uniontech.com>  Thu, 03 Jul 2025 21:12:58 +0800

=== debian/rules ===
--- 
+++ 
@@ -1,10 +1,15 @@
 #!/usr/bin/make -f
-
-# see FEATURE AREAS in dpkg-buildflags(1)
-export DEB_BUILD_MAINT_OPTIONS = hardening=+all optimize=+lto
-
 DPKG_EXPORT_BUILDFLAGS = 1
 include /usr/share/dpkg/default.mk
+export QT_SELECT = qt5
+
+# 安全编译参数
+export DEB_BUILD_MAINT_OPTIONS = hardening=+all
+export DEB_CFLAGS_MAINT_APPEND = -Wall
+export DEB_CXXFLAGS_MAINT_APPEND = -Wall
+export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed -Wl,-z,relro -Wl,-z,now -Wl,-z,noexecstack -Wl,-E
+
+DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
 
 VERSION = $(DEB_VERSION_UPSTREAM)
 PACK_VER = $(shell echo $(VERSION) | awk -F'[+_~-]' '{print $$1}')

## dtkdeclarative 5.7.21

=== debian/changelog ===
dtkdeclarative (5.7.21) unstable; urgency=medium

  * Release 5.7.21

 --  yeshanshan <packages@deepin.org>  Thu, 14 Aug 2025 19:47:37 +0800

dtkdeclarative (5.7.20) unstable; urgency=medium

  * Release 5.7.20

 --  yeshanshan <yeshanshan@uniontech.com>  Thu, 31 Jul 2025 20:00:52 +0800
